
# XtTable

##### Table Attribute

| 参数 | 说明 | 类型 | 可选值 | 默认值  
| --- | ---| --- | --- | --- |
| data | 显示的数据 | array | --- | --- |
| type | 表格类型，add为仅有添加功能 | String | default/add/edit | default |
| rules | 表单验证规则 | Object | --- | ---- |
| add | 是否显示新增按钮 | Boolean | --- | true |
| editFlag | 是否显示编辑按钮 | Boolean | --- | true |
| successFlag | 是否显示提交按钮 | Boolean | --- | true |
| cancelFlag | 是否显示取消按钮 | Boolean | --- | true |
| deleteFlag | 是否显示删除按钮 | Boolean | --- | true |
| border | 是否显示边框,当显示边框时，列宽可拖动 | Boolean | --- | --- |

##### Table Events

| 事件名 | 说明 | 回调参数 
| --- | ---| --- |
| success | 行内验证提交事件 ,回调(callback(true/false)) (成功)/(失败) | row,callback 
| edit | 行内编辑点击事件 ,回调(callback(true/false)) (成功)/(失败) | row,callback 
| delete | 行内删除事件 ,回调callback(true/false)(成功)/(失败) | row,callback
| add | 新增事件,回调callback(item),item为新增的行内对象 | callback |
| validate | 对整个表格的数据进行校验的方法 | this.$refs[data].validate((validateState) => { if(validateState){ //验证通过 } })
| resetFields | 对整个表格的数据进行校验重置 | this.$refs[data].resetFields();
| selection-change | 当选择项发生变化时会触发该事件 | selection

> ###### add事件的用法
 ```
//第一种用法
<xt-table :data="list" @add="handleAdd">
<xt-table-column label="姓名" prop="name"></xt-table-column>
</xt-table>

export default {
  methods: {
    handleAdd() {
      list.push({
        name: null
      });
    }
  }
}

//第二种用法
<xt-table :data="list" @add="handleAdd">
<xt-table-column label="姓名" prop="name"></xt-table-column>
</xt-table>

export default {
  methods: {
    handleAdd(callback) {
      callback({
        name: null
      }, 0); //callback传的参数： row, index， callback(row, index)
      //index不传默认添加在最后一行，（从 0 开始计算）
    }
  }
}
```

##### Table Methods

| 方法名 | 说明 | 参数 
| --- | --- | --- |
| clearSelection | 用于多选表格，清空用户的选择 | --- |
| toggleRowSelection | 用于多选表格，切换某一行的选中状态，如果使用了第二个参数，则是设置这一行选中与否（selected 为 true 则选中） | row, selected 
| toggleAllSelection | 用于多选表格，切换所有行的选中状态 | --- |

##### TableColumn Attribute

| 参数 | 说明 | 类型 | 可选值 | 默认值 |
| --- | --- | --- | --- | --- |
| type | 对应列的类型。如果设置了 selection 则显示多选框；如果设置了 index 则显示该行的索引（从 1 开始计算）；如果设置了 expand 则显示为一个可展开的按钮；如果设置了 operation 则显示为操作列（增删改查按钮） | String | selection/index/expand/operation | ---
| prop | 对应列内容的字段名 | String | --- | --- |
| propType | 行内编辑框的类型 | String | input/date/number/select/checkbox | input |
| label | 列标题 | String | --- | --- |
| options | 当仅当propType='select'时使用，为下拉框数据 | Array | --- | --- |
| props | 当仅当propType='select'时使用,下拉框显示字段等 | Object | label:下拉框显示的字段，String；value:选择框选择的字段,String；labelProp:该列下不选择时需要显示的字段,String | {label:'label',value:'id',labelProp:false} |
| onlyShow | 当前列是否仅为展示状态 | Boolean | --- | false |
| clearable | 是否可以清空选项,当propType='number'时无效 | Boolean | --- | false |
| filterable | 是否可搜索,当propType='select'时有用 | Boolean | --- | false |
| maxlength | 最长长度 | Number | --- | 50 |
| minlength | 最小长度 | Number | --- | 0 |
| max | 最大值 | Number | --- | --- |
| min | 最小值 | Number | --- | --- |
| placeholder | 输入提示 | String | --- | --- |
| remote | 远程搜索启动,仅propType="select"可用 | Boolean | --- | false |
| remoteMethod | 远程搜索方法,仅propType="select"可用 | Function | --- | --- |
| width | 宽度设置 | Number | --- | --- |

###### TableColumn Events

| 事件名 | 说明 | 回调参数 
| --- | ---| --- |
| change | 值改变时触发 | (value,row,item) value:选中的值，row:该行的数据，item:选择框选中的对象，仅在propType='select'时有值 |

###### Table-column Scoped Slot 
| 名称 | 说明 |
| --- | --- |
| --- | 自定义列的内容，参数为 {row, edit, $index}，edit为是否正在编辑中的状态Boolean类型 |
| left | 自定义列的内容，当type="operation"时，slot="left",则位于操作按钮的左边 |
| right | 自定义列的内容，当type="operation"时，slot="right",则位于操作按钮的右边 |












