import Table from "../packages/table/index.js";
import TableColumn from "../packages/table-column/index.js";
import InputNumber from "../packages/input-number/index.js";
import ElementUI from "element-ui";
import "../packages/themes/packages/index.scss";

const components = [
  Table,
  TableColumn,
  InputNumber
];
const install = function (Vue) {
  if (install.installed) {return;}
  components.map((component) => {
    Vue.component(component.name, component);
  });
  Vue.use(ElementUI);
};

if (typeof window !== "undefined" && window.Vue) {
  install(window.Vue);
}

export default {
  version: "1.0.18",
  install,
  Table,
  TableColumn,
  InputNumber
};
